using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Products;
namespace CMSMicroservice.Protobuf.Validator.Products;

public class GetAllProductsByFilterRequestValidator : AbstractValidator<GetAllProductsByFilterRequest>
{
    public GetAllProductsByFilterRequestValidator()
    {
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetAllProductsByFilterRequest>.CreateWithOptions((GetAllProductsByFilterRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
